//
//  NSDate+EWECategory.m
//  MDTPro
//
//  Created by William on 16/9/23.
//  Copyright © 2016年 EWell. All rights reserved.
//

#import "NSDate+EWECategory.h"

@implementation NSDate (EWECategory)


+ (NSString*)ageWithBirthday:(NSString*)birth{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd"];
    //生日
    NSDate *birthDay = [dateFormatter dateFromString:birth];
    return [self ageWithBirthdayDate:birthDay];
}

+ (NSString*)ageWithBirthdayDate:(NSDate*)birthDay{
    
    //第一种仅仅得出年份差的年龄
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd"];
    //当前时间
    NSDate *currentDate = [NSDate date];
    NSTimeInterval time=[currentDate timeIntervalSinceDate:birthDay];
    int age = ((int)time)/(3600*24*365);
    return [NSString stringWithFormat:@"%d岁",age];
}

+ (NSString*)ageDetailWithBirthday:(NSString*)birth{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd"];
    //生日
    NSDate *birthDay = [dateFormatter dateFromString:birth];
    return [self ageDetailWithBirthdayDate:birthDay];
}

+ (NSString*)ageDetailWithBirthdayDate:(NSDate*)birthDay{
    //另外一种得出详细到天的年龄
    NSCalendar *calendar = [NSCalendar currentCalendar];//定义一个NSCalendar对象
    
    NSDate *nowDate = [NSDate date];
    //用来得到详细的时差
    unsigned int unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    NSDateComponents *date = [calendar components:unitFlags fromDate:birthDay toDate:nowDate options:0];
    NSString* age = @"";
    if([date year] >0)
    {
        age = [NSString stringWithFormat:(@"%ld岁%ld月%ld天"),(long)[date year],(long)[date month],(long)[date day]];
    }
    else if([date month] >0)
    {
        age = [NSString stringWithFormat:(@"%ld月%ld天"),(long)[date month],(long)[date day]];
    }
    else if([date day]>0){
        age = [NSString stringWithFormat:(@"%ld天"),(long)[date day]];
    }
    else if([date hour] > 0){
        age = [NSString stringWithFormat:(@"%ld小时"),(long)[date hour]];
    }
    return age;
}

+ (NSComparisonResult)compareMonthStartDate:(NSDate *)startDate endDate:(NSDate *)enddate{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd"];
    NSString* startDateStr = [dateFormatter stringFromDate:startDate];
    NSString* endDateStr = [dateFormatter stringFromDate:enddate];
    if (startDateStr.length != endDateStr.length || startDateStr.length < 7) {
        return NSOrderedSame;
    }
    if ([startDateStr hasPrefix:[endDateStr substringToIndex:7]]) {
        return NSOrderedSame;
    }
    return [startDate compare:enddate];
}

- (NSComparisonResult)compareAge:(int)age{
    NSDate* nowDate = [NSDate date];
    NSTimeInterval time=[nowDate timeIntervalSinceDate:self];
    int myAge = ((int)time)/(3600*24*365);
    //NSOrderedAscending = -1L, NSOrderedSame, NSOrderedDescending
    if (myAge < age) {
        return NSOrderedAscending;
    }else if (myAge == age){
        return NSOrderedSame;
    }else{
        return NSOrderedDescending;
    }

}

+ (NSComparisonResult)compareAge:(int)age birthDate:(NSDate*)birthDate{
    NSDate* nowDate = [NSDate date];
    NSTimeInterval time=[nowDate timeIntervalSinceDate:birthDate];
    int myAge = ((int)time)/(3600*24*365);
    //NSOrderedAscending = -1L, NSOrderedSame, NSOrderedDescending
    if (myAge < age) {
        return NSOrderedAscending;
    }else if (myAge == age){
        return NSOrderedSame;
    }else{
        return NSOrderedDescending;
    }
}

+ (NSString *)dateStrByNSTimeInterval:(NSTimeInterval)timeInterval{
    int hour = (int)timeInterval/3600;
    int minute = ((int)timeInterval%3600)/60;
    int secord = (int)timeInterval%60;
    if (hour>0) {
        return [NSString stringWithFormat:@"%d时%d分%d秒",hour,minute,secord];
    }else if (minute > 0){
        return [NSString stringWithFormat:@"%d分%d秒",minute,secord];
    }else{
        return [NSString stringWithFormat:@"%d秒",secord];
    }
}

+ (NSString*)durationWithFutureDate:(NSDate*)futureDay{
    //另外一种得出详细到天的年龄
    NSCalendar *calendar = [NSCalendar currentCalendar];//定义一个NSCalendar对象
    
    NSDate *nowDate = [NSDate date];
    //用来得到详细的时差
    unsigned int unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    NSDateComponents *date = [calendar components:unitFlags fromDate:nowDate toDate:futureDay options:0];
    NSString* duration = @"";
    if([date year] >0)
    {
        duration = [NSString stringWithFormat:(@"%ld年%ld月%ld天"),(long)[date year],(long)[date month],(long)[date day]];
    }
    else if([date month] >0)
    {
        duration = [NSString stringWithFormat:(@"%ld月%ld天"),(long)[date month],(long)[date day]];
    }
    else if([date day]>0){
        duration = [NSString stringWithFormat:(@"%ld天%ld小时"),(long)[date day],(long)[date hour]];
    }
    else if([date hour] > 0){
        duration = [NSString stringWithFormat:(@"%ld小时%ld分钟"),(long)[date hour],(long)[date minute]];
    }
    else if([date minute] > 0){
        duration = [NSString stringWithFormat:(@"%ld分钟"),(long)[date minute]];
    }
    return duration;
}

+ (NSString *)yearWithDate:(NSDate *)futureDay{
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *comps = [[NSDateComponents alloc] init];
    NSInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitWeekday |
    NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    // 话说在真机上需要设置区域，才能正确获取本地日期，天朝代码:zh_CN
    calendar.locale = [[NSLocale alloc] initWithLocaleIdentifier:@"zh_CN"];
    comps = [calendar components:unitFlags fromDate:futureDay];
    NSInteger yearInt = [comps year];
    return [NSString stringWithFormat:@"%ld",(long)yearInt];

}

+ (NSString *)monthWithDate:(NSDate *)futureDay{
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *comps = [[NSDateComponents alloc] init];
    NSInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitWeekday |
    NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    // 话说在真机上需要设置区域，才能正确获取本地日期，天朝代码:zh_CN
    calendar.locale = [[NSLocale alloc] initWithLocaleIdentifier:@"zh_CN"];
    comps = [calendar components:unitFlags fromDate:futureDay];
    NSInteger monthInt = [comps month];
    return [NSString stringWithFormat:@"%ld",(long)monthInt];
}

+ (NSString *)dayWithDate:(NSDate *)futureDay{
    
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *comps = [[NSDateComponents alloc] init];
    NSInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitWeekday |
    NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    // 话说在真机上需要设置区域，才能正确获取本地日期，天朝代码:zh_CN
    calendar.locale = [[NSLocale alloc] initWithLocaleIdentifier:@"zh_CN"];
    comps = [calendar components:unitFlags fromDate:futureDay];
    NSInteger dayInt = [comps day];
    return [NSString stringWithFormat:@"%ld",(long)dayInt];
}

+ (NSString *)weekDayWithDate:(NSDate *)futureDay{
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *comps = [[NSDateComponents alloc] init];
    NSInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitWeekday |
    NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    // 话说在真机上需要设置区域，才能正确获取本地日期，天朝代码:zh_CN
    calendar.locale = [[NSLocale alloc] initWithLocaleIdentifier:@"zh_CN"];
    comps = [calendar components:unitFlags fromDate:futureDay];
    NSInteger weekInt = [comps weekday];
    NSString* weekStr = @"";
    switch (weekInt) {
        case 1:
            weekStr = @"星期日";
            break;
        case 2:
            weekStr = @"星期一";
            break;
        case 3:
            weekStr = @"星期二";
            break;
        case 4:
            weekStr = @"星期三";
            break;
        case 5:
            weekStr = @"星期四";
            break;
        case 6:
            weekStr = @"星期五";
            break;
        case 7:
            weekStr = @"星期六";
            break;
            
        default:
            weekStr = @"";
            break;
    }
    return weekStr;
}

- (NSString *)weekDayStringzh_CN{
    return [NSDate weekDayWithDate:self];
}


+ (NSString*)currentDateStrWithFormatter:(NSString*)formatter{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
    [dateFormatter setDateFormat:formatter];
    NSDate *currentDate = [NSDate date];
    return [dateFormatter stringFromDate:currentDate];

}
@end
