//
//  NSManagedObject+EWECategory.m
//  DoctorCloudPortal
//
//  Created by William on 16/9/10.
//  Copyright © 2016年 WX. All rights reserved.
//

#import "NSManagedObject+EWECategory.h"
#import <objc/runtime.h>

@implementation NSManagedObject (EWECategory)

- (void)initValueWithDict:(NSDictionary*)dic
{
    unsigned int outCount = 0;
    Class currentClass = [self class];
    
    while (currentClass) {
        objc_property_t* properties = class_copyPropertyList(currentClass, &outCount);
        for (int i = 0; i < outCount; i++) {
            objc_property_t property = properties[i];
            ;
            NSString* propertyNameString = [[NSString alloc] initWithCString:property_getName(property) encoding:NSUTF8StringEncoding];
            NSString* propertyAttributes = [NSString stringWithFormat:@"%s", property_getAttributes(property)];
            
            if ([propertyAttributes rangeOfString:@"D,"].location == NSNotFound && [propertyAttributes rangeOfString:@",D"].location == NSNotFound) {
                continue;
            }
            
            if ([propertyNameString isEqualToString:@"id_i"]) {
                propertyNameString = @"id";
            }
            
            id value;
            
            if ([dic isKindOfClass:[NSDictionary class]]) {
                value = [dic objectForKey:propertyNameString];
                if ([propertyAttributes rangeOfString:@"NSString"].location != NSNotFound) {
                    if ([value isKindOfClass:[NSNumber class]]) {
                        value = [NSString stringWithFormat:@"%ld", (long)[value integerValue]];
                    }
                    value = [NSString stringWithFormat:@"%@", value];
                }
                if ([propertyAttributes rangeOfString:@"NSNumber"].location != NSNotFound) {
                    if ([value isKindOfClass:[NSString class]]) {
                        NSString* newValue = value;
                        int intValue = [newValue intValue];
                        value = [NSNumber numberWithInteger:intValue ? intValue : 0];
                    }
                }
            }
            
            if (value == [NSNull null] || value == nil || [value isEqualToString:@"(null)"]) {
                if ([propertyAttributes rangeOfString:@"NSString"].location != NSNotFound) {
                    if ([propertyNameString isEqualToString:@"id"]) {
                        [self setValue:value forKey:@"id_i"];
                    }
                    else {
                        [self setValue:value forKey:propertyNameString];
                    }
                }
                continue;
            }
            
            if (value) {
                if ([propertyNameString isEqualToString:@"id"]) {
                    [self setValue:value forKey:@"id_i"];
                }
                else {
                    [self setValue:value forKey:propertyNameString];
                }
            }
        }
        Class superclass = [currentClass superclass];
        currentClass = superclass;
        free(properties);
        NSString* className = NSStringFromClass(currentClass);
        if ([className isEqualToString:@"NSManagedObject"]) {
            break;
        }
    }
}

- (NSMutableDictionary *)toDicionary{
    unsigned int outCount = 0;
    Class currentClass = [self class];
    NSMutableDictionary * muDic = [[NSMutableDictionary alloc] init];
    while (currentClass) {
        objc_property_t* properties = class_copyPropertyList(currentClass, &outCount);
        for (int i = 0; i < outCount; i++) {
            objc_property_t property = properties[i];
            ;
            NSString* propertyNameString = [[NSString alloc] initWithCString:property_getName(property) encoding:NSUTF8StringEncoding];
            NSString* propertyAttributes = [NSString stringWithFormat:@"%s", property_getAttributes(property)];
            
            if ([propertyAttributes rangeOfString:@"D,"].location == NSNotFound && [propertyAttributes rangeOfString:@",D"].location == NSNotFound) {
                continue;
            }
            id value;
            
            value = [self valueForKey:propertyNameString];
            
            if (value == [NSNull null] || value == nil || [value isEqualToString:@"(null)"]) {
                if ([propertyAttributes rangeOfString:@"NSString"].location != NSNotFound) {
                    [muDic setValue:@"" forKey:propertyNameString];
                }
                continue;
            }
            if (value) {
                if ([propertyNameString isEqualToString:@"id_i"]) {
                    [muDic setValue:value forKey:@"id"];
                }
                else {
                    [muDic setValue:value forKey:propertyNameString];
                }
            }
        }
        Class superclass = [currentClass superclass];
        currentClass = superclass;
        free(properties);
        NSString* className = NSStringFromClass(currentClass);
        if ([className isEqualToString:@"NSManagedObject"]) {
            break;
        }
    }
    return muDic;
}

@end
