//
//  NSDictionary+WXIntercept.m
//  EPrescriptionStore
//
//  Created by rocky on 16/4/5.
//  Copyright © 2016年 Ewell. All rights reserved.
//

#import "NSMutableDictionary+EWECategory.h"
#import <objc/runtime.h>

@implementation NSMutableDictionary (EWECategory)

- (void)setAnObject:(id)anObject forKey:(NSString *)aKey{
    
    if (anObject && [aKey isKindOfClass:[NSString class]]) {
        [self setObject:anObject forKey:aKey];
    }else{
        //NSLog(@"warning:\nNSMutableDictionary+WXIntercept set nil for key %@",aKey);
    }
}

/**
 *  object 转参数字典集
 *
 *  @param object       要转换的模型
 *  @param parameterKey 参数前缀名
 *
 */
+ (NSMutableDictionary*)parameterDictionaryFromObject:(id)object parameterKey:(NSString*)parameterKey{
    NSMutableDictionary* parameters = @{}.mutableCopy;
    if ([object isKindOfClass:[NSDictionary class]]) {
        for (NSString* key in [object allKeys]) {
            id value = [object objectForKey:key];
            if ([value isKindOfClass:[NSNumber class]]) {
                value = [NSString stringWithFormat:@"%ld",(long)[value integerValue]];
            }
            [parameters setObject:value forKey:[NSString stringWithFormat:@"%@%@",parameterKey,key]];
        }
        return parameters;
    }
//    if ([object respondsToSelector:@selector(toDicionary)]) {
//        NSDictionary* dict = [object performSelector:@selector(toDicionary)];
//        for (NSString* key in [dict allKeys]) {
//            id value = [dict objectForKey:key];
//            if ([value isKindOfClass:[NSNumber class]]) {
//                value = [NSString stringWithFormat:@"%ld",(long)[value integerValue]];
//            }
//            [parameters setObject:value forKey:[NSString stringWithFormat:@"%@%@",parameterKey,key]];
//        }
//    }
    return parameters;
}

@end
