//
//  NSString+EWECategory.m
//  DoctorCloudPortal
//
//  Created by William on 16/9/8.
//  Copyright © 2016年 WX. All rights reserved.
//

#import "NSString+EWECategory.h"
#import "JSONKit.h"
#import "OrderedDictionary.h"

@implementation NSString (EWECategory)

+ (NSString*)ewell_URLEncode:(NSString*)url
{
    NSString* encodePath = [url stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet characterSetWithCharactersInString:@":/?#[]@!$ &'()*+,;=\"<>%{}|\\^~`"].invertedSet];
    //`#%^{}\"[]|\\<>
    if (encodePath) {
        return encodePath;
    }
    return url;
}

+ (NSString *)changeJsonStringToTrueJsonString:(NSString *)json
{
    NSString *validString = [json stringByReplacingOccurrencesOfString:@" " withString:@""];
    // 将没有双引号的替换成有双引号的
//    validString = [validString stringByReplacingOccurrencesOfString:@"(\\w+)\\s*:([^A-Za-z0-9_])" withString:@"\"$1\":$2" options:NSRegularExpressionSearch range:NSMakeRange(0, [validString length])];
    
    
    //把'单引号改为双引号"
    validString = [validString stringByReplacingOccurrencesOfString:@"([:\\[,\\{])'"
                                                         withString:@"$1\""
                                                            options:NSRegularExpressionSearch
                                                              range:NSMakeRange(0, [validString length])];
    validString = [validString stringByReplacingOccurrencesOfString:@"'([:\\],\\}])"
                                                         withString:@"\"$1"
                                                            options:NSRegularExpressionSearch
                                                              range:NSMakeRange(0, [validString length])];
    validString = [validString stringByReplacingOccurrencesOfString:@"\"{" withString:@"{"];
    validString = [validString stringByReplacingOccurrencesOfString:@"}\"" withString:@"}"];
    
    //再重复一次 将没有双引号的替换成有双引号的
//    validString = [validString stringByReplacingOccurrencesOfString:@"([:\\[,\\{])(\\w+)\\s*:"
//                                                         withString:@"$1\"$2\":"
//                                                            options:NSRegularExpressionSearch
//                                                              range:NSMakeRange(0, [validString length])];
    return validString;
}

+ (NSString*)utf8_UrlEncode:(NSString*)urlStr
{
    NSArray* array = [urlStr componentsSeparatedByString:@"/"];
    NSMutableString* encodeUrlMutStr = @"".mutableCopy;
    NSString* encodeUrl;
    for (NSString* str in array) {
        if ([str isKindOfClass:[NSString class]]) {
            NSString* utf8Str = [str stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
            [encodeUrlMutStr appendFormat:@"%@/", utf8Str];
        }
        else {
            [encodeUrlMutStr appendString:@"/"];
        }
    }
    if (encodeUrlMutStr.length > 1) {
        encodeUrl = [NSString stringWithString:encodeUrlMutStr];
        encodeUrl = [encodeUrl substringToIndex:encodeUrl.length - 1];
    }
    return encodeUrl;
}

+ (id)orderDictionaryOrArrayWithJsonString:(NSString*)jsonString
{
    id dic;
    
    if (jsonString == nil) {
        
        return nil;
    }
    if ([jsonString isKindOfClass:[NSDictionary class]] || [jsonString isKindOfClass:[NSArray class]]) {
        dic = jsonString;
    }
    NSError* err;
    if ([jsonString isKindOfClass:[NSString class]]) {
        jsonString = [jsonString stringByReplacingOccurrencesOfString:@"\n" withString:@""];
        NSData* jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
        JSONDecoder *decoder = [[JSONDecoder alloc] init];
        dic = [decoder objectWithData:jsonData error:&err];
    }
    if ([dic isKindOfClass:[OrderedDictionary class]]) {
        NSArray* keyArray = [dic allKeys];
        
        if (keyArray && keyArray.count > 0) {
            OrderedDictionary* mutableDict = [dic mutableCopy];
            for (NSString* key in keyArray) {
                id tempValue = [mutableDict objectForKey:key];
                if ([tempValue isKindOfClass:[NSString class]] && [self isJsonString:tempValue]) {
                    id itemData = [self orderDictionaryOrArrayWithJsonString:tempValue];
                    if (!itemData) {
                        continue;
                    }
                    [mutableDict removeObjectForKey:key];
                    
                    [mutableDict setObject:[self orderDictionaryOrArrayWithJsonString:tempValue] forKey:key];
                }
            }
            return mutableDict;
        }
    }
    if ([dic isKindOfClass:[NSArray class]]) {
        NSArray* tempArray = dic;
        if (tempArray.count > 0) {
            NSMutableArray* tempMutableArray = @[].mutableCopy;
            for (id item in tempArray) {
                id itemData = [self orderDictionaryOrArrayWithJsonString:item];
                if (!itemData) {
                    continue;
                }
                [tempMutableArray addObject:itemData];
            }
            return tempMutableArray;
        }
    }
    
    if (err) {
        
        //NSLog(@"json解析失败：%@", err);
        
        return nil;
    }

    
    return dic;
}

+ (id)dictionaryOrArrayWithJsonString:(NSString*)jsonString
{
    id dic;

    if (jsonString == nil) {

        return nil;
    }
    if ([jsonString isKindOfClass:[NSDictionary class]] || [jsonString isKindOfClass:[NSArray class]]) {
        dic = jsonString;
    }
    NSError* err;
    if ([jsonString isKindOfClass:[NSString class]]) {
        jsonString = [jsonString stringByReplacingOccurrencesOfString:@"\n" withString:@""];
        NSData* jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
        dic = [NSJSONSerialization JSONObjectWithData:jsonData

                                              options:NSJSONReadingMutableContainers

                                                error:&err];
    }

    if ([dic isKindOfClass:[NSDictionary class]]) {
        NSArray* keyArray = [dic allKeys];

        if (keyArray && keyArray.count > 0) {
            NSMutableDictionary* mutableDict = [[NSMutableDictionary alloc] initWithDictionary:dic];
            for (NSString* key in keyArray) {
                id tempValue = [mutableDict objectForKey:key];
                if ([tempValue isKindOfClass:[NSString class]] && [self isJsonString:tempValue]) {
                    id itemData = [self dictionaryOrArrayWithJsonString:tempValue];
                    if (!itemData) {
                        continue;
                    }
                    [mutableDict removeObjectForKey:key];

                    [mutableDict setObject:[self dictionaryOrArrayWithJsonString:tempValue] forKey:key];
                }
            }
            return mutableDict;
        }
    }
    if ([dic isKindOfClass:[NSArray class]]) {
        NSArray* tempArray = dic;
        if (tempArray.count > 0) {
            NSMutableArray* tempMutableArray = @[].mutableCopy;
            for (id item in tempArray) {
                id itemData = [self dictionaryOrArrayWithJsonString:item];
                if (!itemData) {
                    continue;
                }
                [tempMutableArray addObject:itemData];
            }
            return tempMutableArray;
        }
    }

    if (err) {

        //NSLog(@"json解析失败：%@", err);

        return nil;
    }

    return dic;
}

+ (BOOL)isJsonString:(NSString*)string
{
    NSData* jsonData = [string dataUsingEncoding:NSUTF8StringEncoding];

    NSError* err;

    id dic = [NSJSONSerialization JSONObjectWithData:jsonData

                                             options:NSJSONReadingMutableContainers

                                               error:&err];
    if ([dic isKindOfClass:[NSDictionary class]] || [dic isKindOfClass:[NSArray class]]) {
        return YES;
    }
    return false;
}

+ (NSString*)toJsonstring:(id)data
{
    NSError* parseError = nil;
    id decodeData;
    if ([data isKindOfClass:[NSString class]]){
        return data;
    }
    if ([data isKindOfClass:[NSArray class]] || [data isKindOfClass:[NSMutableArray class]]) {
        NSMutableArray* mutableArray = @[].mutableCopy;
        NSArray* array = data;
        for (id item in array) {
            if([item isKindOfClass:[NSDictionary class]] || [item isKindOfClass:[NSDictionary class]]) {
                break;
            }
            if ([item isKindOfClass:[OrderedDictionary class]]) {
                OrderedDictionary* orderDict = item;
                [mutableArray addObject:[orderDict toDictionary]];
            }
        }
        if (mutableArray.count > 0) {
            decodeData = mutableArray;
        }else{
            decodeData = data;
        }
    }else {
        decodeData = data;
    }
    NSData* jsonData = [NSJSONSerialization dataWithJSONObject:decodeData options:NSJSONWritingPrettyPrinted error:&parseError];
    NSString* result = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
    result = [result stringByReplacingOccurrencesOfString:@"(null)" withString:@""];
    return result;
}

+ (NSString*)toJsonstringUrlEncoded:(id)data
{
    NSError* parseError = nil;
    if (data == nil) {
        return nil;
    }
    if ([data isKindOfClass:[NSString class]]) {
        return [data stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet characterSetWithCharactersInString:@":/?#[]@!$ &'()*+,;=\"<>%{}|\\^~`"].invertedSet];
    }
    
    if ([data isKindOfClass:[NSArray class]] || [data isKindOfClass:[NSDictionary class]]) {
        NSData* jsonData = [NSJSONSerialization dataWithJSONObject:data options:NSJSONWritingPrettyPrinted error:&parseError];
        NSString* result = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
        result = [result stringByReplacingOccurrencesOfString:@"(null)" withString:@""];
        
        NSString* encodePath = [result stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet characterSetWithCharactersInString:@":/?#[]@!$ &'()*+,;=\"<>%{}|\\^~`"].invertedSet];
        //`#%^{}\"[]|\\<>
        if (encodePath) {
            return encodePath;
        }
        return result;
    }
    return nil;
    
}
+ (NSString*)toJsonstringUrlDecoder:(id)data
{
    NSError* parseError = nil;
    NSData* jsonData = [NSJSONSerialization dataWithJSONObject:data options:NSJSONWritingPrettyPrinted error:&parseError];
    NSString* result = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
    result = [result stringByReplacingOccurrencesOfString:@"(null)" withString:@""];
    
    NSArray* array = [result componentsSeparatedByString:@"/"];
    NSMutableString* encodeUrlMutStr = @"".mutableCopy;
    NSString* encodeUrl;
    for (NSString* str in array) {
        if ([str isKindOfClass:[NSString class]]) {
            NSString* utf8Str = [str stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
            [encodeUrlMutStr appendFormat:@"%@/", utf8Str];
        }
        else {
            [encodeUrlMutStr appendString:@"/"];
        }
    }
    if (encodeUrlMutStr.length > 1) {
        encodeUrl = [NSString stringWithString:encodeUrlMutStr];
        encodeUrl = [encodeUrl substringToIndex:encodeUrl.length - 1];
    }
    return encodeUrl;
}

+ (BOOL)isValidateString:(NSString*)string regExp:(NSString*)regExp
{
    // NSString *emailRegex = @"[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,4}";
    NSPredicate* predicate = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", regExp];
    return [predicate evaluateWithObject:string];
}

+ (BOOL)isHtmlStr:(NSString*)str
{

    if ([str rangeOfString:@"<html>"].location != NSNotFound || [str rangeOfString:@"<HTML>"].location != NSNotFound) {
        return YES;
    }
    return NO;
}

+ (NSAttributedString*)AttributedStringFromHtmlString:(NSString*)htmlString
{
    return [[NSAttributedString alloc] initWithData:[htmlString dataUsingEncoding:NSUnicodeStringEncoding] options:@{ NSDocumentTypeDocumentAttribute : NSHTMLTextDocumentType }
                                 documentAttributes:nil
                                              error:nil];
}

+ (NSMutableAttributedString*)attributedStrByStr:(NSString*)string lineSpacing:(NSInteger)lineSpacing font:(UIFont*)font
{
    NSMutableAttributedString* attributedString1 = [[NSMutableAttributedString alloc] initWithString:string ? string : @""];
    NSMutableParagraphStyle* paragraphStyle1 = [[NSMutableParagraphStyle alloc] init];
    [paragraphStyle1 setLineSpacing:lineSpacing];
    [attributedString1 addAttribute:NSParagraphStyleAttributeName value:paragraphStyle1 range:NSMakeRange(0, [string length])];
    [attributedString1 addAttribute:NSFontAttributeName value:font range:NSMakeRange(0, [string length])];
    return attributedString1;
    //[self.shapeLabel setAttributedText:attributedString1];
    //[self.shapeLabel sizeToFit];
}

+ (NSAttributedString*)attributedStringByStringOrHtmlString:(NSString*)string lineSpace:(NSInteger)lineSpace font:(UIFont*)font
{
    if ([self isHtmlStr:string]) {
        NSAttributedString* attributedStr = [self AttributedStringFromHtmlString:string];
        NSMutableAttributedString* mutAttributedStr = [[NSMutableAttributedString alloc] initWithAttributedString:attributedStr];
        NSMutableParagraphStyle* paragraphStyle1 = [[NSMutableParagraphStyle alloc] init];
        [paragraphStyle1 setLineSpacing:lineSpace];
        [mutAttributedStr addAttribute:NSParagraphStyleAttributeName value:paragraphStyle1 range:NSMakeRange(0, [attributedStr.string length])];

        [mutAttributedStr addAttribute:NSFontAttributeName value:font range:NSMakeRange(0, [attributedStr.string length])];
        return mutAttributedStr;
    }
    else {
        return [self attributedStrByStr:string lineSpacing:lineSpace font:font];
    }
}

// pinyin
- (NSString*)transformToPinyin
{
    NSMutableString* mutableString = [NSMutableString stringWithString:self];
    CFStringTransform((CFMutableStringRef)mutableString, NULL, kCFStringTransformToLatin, false);
    mutableString = (NSMutableString*)[mutableString stringByFoldingWithOptions:NSDiacriticInsensitiveSearch locale:[NSLocale currentLocale]];
    mutableString = [[mutableString stringByReplacingOccurrencesOfString:@" " withString:@""] mutableCopy];
    return mutableString.lowercaseString;
}
//
- (NSString*)transformToPinyinFirstLetter
{
    NSMutableString* stringM = [NSMutableString string];

    NSString* temp = nil;
    for (int i = 0; i < [self length]; i++) {

        temp = [self substringWithRange:NSMakeRange(i, 1)];

        NSMutableString* mutableString = [NSMutableString stringWithString:temp];

        CFStringTransform((CFMutableStringRef)mutableString, NULL, kCFStringTransformToLatin, false);

        mutableString = (NSMutableString*)[mutableString stringByFoldingWithOptions:NSDiacriticInsensitiveSearch locale:[NSLocale currentLocale]];

        mutableString = [[mutableString substringToIndex:1] mutableCopy];

        [stringM appendString:(NSString*)mutableString];
    }
    return stringM.lowercaseString;
}

- (NSAttributedString*)attributedStrByLineSpacing:(NSInteger)lineSpacing font:(UIFont*)font
{
    return [NSString attributedStrByStr:self lineSpacing:lineSpacing font:font];
}


//是否含有表情
- (BOOL)stringContainsEmoji:(NSString *)string
{
    __block BOOL returnValue = NO;
    
    [string enumerateSubstringsInRange:NSMakeRange(0, [string length])
                               options:NSStringEnumerationByComposedCharacterSequences
                            usingBlock:^(NSString *substring, NSRange substringRange, NSRange enclosingRange, BOOL *stop) {
                                const unichar hs = [substring characterAtIndex:0];
                                if (0xd800 <= hs && hs <= 0xdbff) {
                                    if (substring.length > 1) {
                                        const unichar ls = [substring characterAtIndex:1];
                                        const int uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;
                                        if (0x1d000 <= uc && uc <= 0x1f77f) {
                                            returnValue = YES;
                                        }
                                    }
                                } else if (substring.length > 1) {
                                    const unichar ls = [substring characterAtIndex:1];
                                    if (ls == 0x20e3) {
                                        returnValue = YES;
                                    }
                                } else {
                                    if (0x2100 <= hs && hs <= 0x27ff) {
                                        returnValue = YES;
                                    } else if (0x2B05 <= hs && hs <= 0x2b07) {
                                        returnValue = YES;
                                    } else if (0x2934 <= hs && hs <= 0x2935) {
                                        returnValue = YES;
                                    } else if (0x3297 <= hs && hs <= 0x3299) {
                                        returnValue = YES;
                                    } else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030 || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b || hs == 0x2b50) {
                                        returnValue = YES;
                                    }
                                }
                            }];
    
    return returnValue;
}

@end
